varying mediump vec2 var_texcoord0;
varying lowp vec4 var_color;

uniform lowp sampler2D texture_sampler;

vec4 color_1 = vec4(0.8, 0.8, 0.8, 1);
vec4 color_2 = vec4(0.6, 0.6, 0.6, 1);
vec4 color_3 = vec4(0.533, 0.533, 0.533, 1);
vec4 color_4 = vec4(0.467,0.467,0.467,1);
vec4 color_5 = vec4(0.4,0.4,0.4,1);
vec4 color_6 = vec4(0.333,0.333,0.333,1);
vec4 color_7 = vec4(0.267,0.267,0.267,1);
vec4 color_8 = vec4(0.2,0.2,0.2,1);

uniform lowp vec4 replace_1;
uniform lowp vec4 replace_2;
uniform lowp vec4 replace_3;
uniform lowp vec4 replace_4;
uniform lowp vec4 replace_5;
uniform lowp vec4 replace_6;
uniform lowp vec4 replace_7;
uniform lowp vec4 replace_8;

vec4 eps = vec4(0.0009, 0.0009, 0.0009, 0.0009);

void main()
{
    lowp vec4 pixel = texture2D(texture_sampler, var_texcoord0.xy);
 
    if (all(greaterThanEqual(pixel, vec4(color_1 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_1 + eps))))
    pixel = vec4(replace_1);

    if (all(greaterThanEqual(pixel, vec4(color_2 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_2 + eps))))
    pixel = vec4(replace_2);

    if (all(greaterThanEqual(pixel, vec4(color_3 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_3 + eps))))
    pixel = vec4(replace_3);

    if (all(greaterThanEqual(pixel, vec4(color_4 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_4 + eps))))
    pixel = vec4(replace_4);

    if (all(greaterThanEqual(pixel, vec4(color_5 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_5 + eps))))
    pixel = vec4(replace_5);

    if (all(greaterThanEqual(pixel, vec4(color_6 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_6 + eps))))
    pixel = vec4(replace_6);

    if (all(greaterThanEqual(pixel, vec4(color_7 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_7 + eps))))
    pixel = vec4(replace_7);

    if (all(greaterThanEqual(pixel, vec4(color_8 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_8 + eps))))
    pixel = vec4(replace_8);

    gl_FragColor = pixel * var_color;
}