varying mediump vec2 var_texcoord0;

uniform lowp sampler2D texture_sampler;

uniform lowp vec4 color_1;
uniform lowp vec4 color_2;
uniform lowp vec4 replace_1;
uniform lowp vec4 replace_2;
vec4 eps = vec4(0.009, 0.009, 0.009, 0.009);

void main()
{
    vec4 pixel = texture2D(texture_sampler, var_texcoord0.xy);
    
    // color_1, replace_1
    if (all(greaterThanEqual(pixel, vec4(color_1 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_1 + eps))))
    pixel = vec4(replace_1);

    // color_2, replace_2
    if (all(greaterThanEqual(pixel, vec4(color_2 - eps))) &&
    all(lessThanEqual(pixel, vec4(color_2 + eps))))
    pixel = vec4(replace_2);
    
    gl_FragColor = pixel;
}